/*

The MIT License

Copyright (c) 2008 Janvarev Vladislav, http://janvarev.ru/CuePointsFromSRTEn

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

*/
package comvideo.subtitles
{
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	import mx.controls.videoClasses.CuePointManager;
	
	public class CuePointsFromSRT extends EventDispatcher
	{
		public function CuePointsFromSRT() {
			super();
		}
		
		public var srtLoader: URLLoader;
		public var cuePointManager: CuePointManager;			
		
		public function loadFromURL(request:URLRequest):void {
			srtLoader = new URLLoader();
			srtLoader.addEventListener(Event.COMPLETE, onSubtitlesLoad, false, 0, true);
			srtLoader.load(request);
		}
		
		private function onSubtitlesLoad(event:Event):void {
			srtLoader.removeEventListener(Event.COMPLETE, onSubtitlesLoad, false);
			dispatchEvent(new Event("srtComplete"));
			//Alert.show(srtLoader.data);
			loadFromString(srtLoader.data);
		}		
		
		public function loadFromString(str:String):void {
			var lines:Array = str.split("\r\n");
			if(lines.length == 1) {
				lines = str.split("\n");
			}
			var numLines:uint = lines.length;
			
			var startNewSub: Boolean = false;
			var curStr: String;
			
			var curSub: String = "";
			var curTime: String = "";
			//var curObj: Object;
			
			for (var i:uint = 0; i < numLines; i++) {
			    curStr = lines[i];
			    // if new subblock already started
			    if(startNewSub) {
			    	// if subblock just end
			    	if(curStr == "" || curStr == "\r") {
			    		startNewSub = false;
			    		
			    		doubleCueFromTimeAndName(curTime, curSub);
			    		curTime = "";
			    		curSub = "";
			    	} else {
			    		// add text from this line to subtitle
			    		if(curSub!="") curSub += "\n";
			    		curSub += curStr;	
			    	}
			    } else {
			 		if(curStr.length > 5) {
			 			startNewSub = true;
			 			curTime = curStr;
			 		} else {
			 			// do nothing
			 		}
			    }
			}

		}
		
		public function cuePointFromTimeAndName(time:String, name:String):Object {
			//return null;
			var obj:Object = new Object;
			obj["name"] = name;
			
			var time1: Array = time.split(":");
			var time2: Array = (time1[2] as String).split(",");
			
			obj["time"] = 0 + parseInt(time1[0]) * 3600 + parseInt(time1[1]) * 60 + parseInt(time2[0]) + parseInt(time2[1]) / 1000;
			return obj;  		
		}
		
		private function doubleCueFromTimeAndName(times: String, name: String):void {
			/*
			trace("times: "+times);
			trace("name: "+name);
			trace("----");
			*/
			var arrTimes:Array = times.split(" --> ", 2);
			
			cuePointManager.addCuePoint(cuePointFromTimeAndName(arrTimes[0], name));
			cuePointManager.addCuePoint(cuePointFromTimeAndName(arrTimes[1], "{close}"));
			
			return;
		}
	}
}